Imports System.Data.SqlClient
Imports System.Reflection

Public Class cBerechtigungenBenutzerGruppenZuordnung_List
    Public LIST As New List(Of cBerechtigungenBenutzerGruppenZuordnung)
    Dim SQL As New SQL
    'Dim listTodelete As New List(Of cOfferte)
    Dim mit_Id
    Sub New(mit_Id)
        LOAD_LIST(mit_Id)
    End Sub
    Public Sub CLEAR()
        LIST.Clear()
    End Sub
    Public Sub ADD(eb_EMail As String, Optional cc As Boolean = False, Optional bcc As Boolean = False)
        ' Dim l As New cOfferte
        'l.eb_bcc = bcc
        'LIST.Add(l)
    End Sub

    Public Sub LOAD_LIST(mit_Id)
        Try
            LIST.Clear()
            Using conn As SqlConnection = SQL.GetNewOpenConnectionADMIN()
                Using cmd As New SqlCommand("SELECT *,(SELECT [bergr_bezeichnung] FROM tblBerechtigungenGruppen WHERE [bergr_id]=[berbgz_bergrId])  as Gruppenbezeichnung FROM tblBerechtigungenBenutzerGruppenZuordnung  WHERE berbgz_mitId=@berbgz_mitId  ", conn) 'SELECT * FROM tblBerechtigungenBenutzerGruppenZuordnung WHERE berbgz_mitId=@berbgz_mitId", conn)
                    cmd.Parameters.AddWithValue("@berbgz_mitId", mit_Id)
                    '  cmd.Parameters.AddWithValue("@OffertenNr", OffertenNr)
                    Dim dr = cmd.ExecuteReader()
                    While dr.Read
                        Dim l As New cBerechtigungenBenutzerGruppenZuordnung
                        For Each i In l.getParameterList()
                            Dim propInfo As PropertyInfo = l.GetType.GetProperty(i.Scalarvariable)
                            If dr.Item(i.Text) Is DBNull.Value Then
                                propInfo.SetValue(l, Nothing)
                            Else
                                propInfo.SetValue(l, dr.Item(i.Text))
                            End If
                        Next
                        '  l.LOAD_ZUORD()
                        LIST.Add(l)
                    End While
                    dr.Close()
                End Using
            End Using
        Catch ex As Exception
            MsgBox("Fehler in der Funktion '" & System.Reflection.MethodInfo.GetCurrentMethod.Name & "'" & vbNewLine & vbNewLine & ex.Message & vbNewLine & vbNewLine & ex.StackTrace)
        End Try
    End Sub
End Class



Public Class cBerechtigungenBenutzerGruppenZuordnung
    Property berbgz_id As Integer
    Property berbgz_progId As Integer
    Property berbgz_mitId As Integer
    Property Gruppenbezeichnung As Object = Nothing

    Property berbgz_bergrId As Integer

    Dim SQL As New SQL

    Function getParameterList() As List(Of VERAG_PROG_ALLGEMEIN.SQLVariable)
        Dim list As New List(Of VERAG_PROG_ALLGEMEIN.SQLVariable)
        list.Add(New VERAG_PROG_ALLGEMEIN.SQLVariable("berbgz_id", berbgz_id, , True))
        list.Add(New VERAG_PROG_ALLGEMEIN.SQLVariable("berbgz_progId", berbgz_progId))
        list.Add(New VERAG_PROG_ALLGEMEIN.SQLVariable("berbgz_mitId", berbgz_mitId))
        list.Add(New VERAG_PROG_ALLGEMEIN.SQLVariable("Gruppenbezeichnung", Gruppenbezeichnung, , , True))
        list.Add(New VERAG_PROG_ALLGEMEIN.SQLVariable("berbgz_bergrId", berbgz_bergrId))
        Return list
    End Function


    Public Function INSERT() As String
        Try
            Dim list As List(Of SQLVariable) = getParameterList()
            Dim str As String = ""
            Dim values As String = ""
            For Each i In list
                If Not (i.isPrimaryParam Or i.isonlyForLoad) Then
                    str &= "[" & i.Text & "],"
                    values &= "@" & i.Scalarvariable & "," '.Replace("-", "").Replace(" ", "") & ","
                End If
            Next
            str = str.Substring(0, str.Length - 1) 'wg. ','
            values = values.Substring(0, values.Length - 1) 'wg. ','
            '  MsgBox(" INSERT INTO tblBerechtigungsObjekteZuordnung  (" & str & ") VALUES(" & values & ")  ")
            SQL.doSQLVarListID(berbgz_id, " INSERT INTO tblBerechtigungenBenutzerGruppenZuordnung  (" & str & ") VALUES(" & values & ")  ", "ADMIN", , list)
        Catch ex As Exception
            MsgBox("Fehler in der Funktion '" & System.Reflection.MethodInfo.GetCurrentMethod.Name & "'" & vbNewLine & vbNewLine & ex.Message & vbNewLine & vbNewLine & ex.StackTrace)
        End Try
        Return ""
    End Function


    Public Function DELETE() As String
        Try
            ' SQL.doSQL("DELETE  FROM tblBerechtigungenBenutzerGruppenZuordnung  WHERE [berbgz_bergrId]=" & Me.bergr_id, "ADMIN") 'Zuerst die Zuordnungen
            '  SQL.doSQL("DELETE  FROM tblBerechtigungsObjekteZuordnung  WHERE [beroz_art]='G' AND [beroz_bergrId]=" & Me.bergr_id, "ADMIN") 'Zuerst die Zuordnungen
            SQL.doSQL("DELETE FROM tblBerechtigungenBenutzerGruppenZuordnung  WHERE berbgz_id=" & Me.berbgz_id, "ADMIN")
        Catch ex As Exception
            MsgBox("Fehler in der Funktion '" & System.Reflection.MethodInfo.GetCurrentMethod.Name & "'" & vbNewLine & vbNewLine & ex.Message & vbNewLine & vbNewLine & ex.StackTrace)
        End Try
        Return ""
    End Function

End Class
